import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URLDecoder;

import org.apache.commons.httpclient.Cookie;
import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethodBase;
import org.apache.commons.httpclient.HttpState;
import org.apache.commons.httpclient.cookie.CookiePolicy;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.MultipartPostMethod;
import org.apache.commons.httpclient.util.Base64;

public class Uploader {

	private final String hostname;
	private final String username;
	private final String password;

	private final String filename;
	private final File file;
	private HttpState state = null;
	private HttpClient client = null;
	private HostConfiguration conf = null;

	/**
	 * The constructor
	 * 
	 * @param hostname
	 * @param username
	 * @param password
	 */
	public Uploader(
		final String hostname,
		final String username,
		final String password,
		final String filename) {
		System.setProperty(
			"org.apache.commons.logging.Log",
			"org.apache.commons.logging.impl.SimpleLog");
		System.setProperty(
			"org.apache.commons.logging.simplelog.log.httpclient.wire",
			"debug");
		System.setProperty(
			"org.apache.commons.logging.simplelog.log.org.apache.commons.httpclient",
			"debug");

		this.hostname = hostname;
		this.username = username;
		this.password = password;
		this.filename = filename;
		this.file = new File(filename);
	}

	/**
	 * Program entry.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		Uploader u =
			new Uploader(
				"http://azure.freeservers.com",
				"azure.freeservers.com",
				"m6m6m6",
				"/udir/projects/uploaded/src/bom12.txt");
		u.upload();
	}

	/**
	 * Connect to the server and start a session.
	 * 
	 * @return true is connection was estalished
	 */
	protected boolean connect() {
		System.out.println("Connecting ...");

		state = new HttpState();
		client = new HttpClient();
		conf = new HostConfiguration();
		conf.setHost("freeservers.com");
		//conf.setProxy("172.25.128.253",3128);
		state.setCookiePolicy(CookiePolicy.RFC2109);
		client.setState(state);
		return true;
	}

	/**
	 *	Disconnect from server.
	 */
	protected void disconnect() {
		state = null;
		client = null;
		conf = null;
		System.out.println("Disconnected.");
	}

	protected void addCommonHeaders(HttpMethodBase m) {
		m.addRequestHeader("User-Agent","Mozilla/5.0 (X11; U; SunOS sun4u; en-US; rv:1.4) Gecko/20030701");
		m.addRequestHeader("Accept-Language","en-us,en;q=0.5");
		//m.addRequestHeader("Accept-Encoding","gzip,deflate");
		m.addRequestHeader("Keep-Alive","300");
		m.addRequestHeader("Accept-Charset","utf-8;q=0.7,*;q=0.7");
		m.addRequestHeader("Proxy-Connection","keep-alive");
		m.setHttp11(true); 
	}

	public void upload() {

		connect();
		GetMethod m = null;
		try {
			String userpass = this.username + ":" + this.password;
			userpass = new String(Base64.encode(userpass.getBytes()));

			//simulate 'Login' button pressing
			String url = "http://members.freeservers.com/cgi-bin/members?verify=1&site="+username+"&redirect=/cgi-bin/util/site_admin&userpass="+userpass;
			m = new GetMethod(url);
			addCommonHeaders(m);
			conf.setHost("members.freeservers.com");
			//m.addRequestHeader("Host","members.freeservers.com");
			m.setFollowRedirects(false);
			client.executeMethod(conf,m,state);
			String body = m.getResponseBodyAsString();
			//TODO remove at delivery
			saveFile(body,"1.html");
			

			//take from headers the new location
			url = m.getResponseHeader("Location").getValue();
			m.releaseConnection();
			
			System.out.println("\n\n\n");
			m = new GetMethod(url);
			conf.setHost("azure.freeservers.com");
			addCommonHeaders(m);
			m.addRequestHeader("Host","azure.freeservers.com");
			m.setFollowRedirects(false);
			client.executeMethod(conf,m,state);
			body = m.getResponseBodyAsString();
			//TODO remove at delivery
			saveFile(body,"2.html");
			
			//take from headers the new location
			url = m.getResponseHeader("Location").getValue();			
			m.releaseConnection();

			System.out.println("\n\n\n");
			
			m = new GetMethod(url);
			conf.setHost("azure.freeservers.com");
			addCommonHeaders(m);
			//m.addRequestHeader("Host","azure.freeservers.com");
			m.setFollowRedirects(false);
			client.executeMethod(conf,m,state);
			int status = m.getStatusCode();
			body = m.getResponseBodyAsString();
			// TODO remove at delivery
			saveFile(body,"3.html");
			m.releaseConnection();

			if(status == 200) {
				System.out.println("Login successfull!"); 
			} else {
				System.out.println("Login FAILED!");
			}

//			callTrack("http://azure.freeservers.com/fs_img/freeservers.css");
//			
//			state.addCookie(new Cookie("freeservers.com","site_service_level","100", "/", null, false));
//			state.addCookie(new Cookie("freeservers.com","site_status","100", "/", null, false));


			// go to File Manager
			url = "http://azure.freeservers.com/cgi-bin/util/fm";
			m = new GetMethod(url);
			conf.setHost("azure.freeservers.com");
			addCommonHeaders(m);
			//m.addRequestHeader("Host","azure.freeservers.com");
			m.setFollowRedirects(true);
			client.executeMethod(conf,m,state);
			body = m.getResponseBodyAsString();
			// TODO remove at delivery
			saveFile(body,"fm.html");
			m.releaseConnection();
			
			System.out.println("=====================================\n\n\n");

			// go to File Manager
			url = "http://azure.freeservers.com/cgi-bin/util/fm/?showupload=1";
			m = new GetMethod(url);
			conf.setHost("azure.freeservers.com");
			addCommonHeaders(m);
			m.setFollowRedirects(true);
			client.executeMethod(conf,m,state);
			body = m.getResponseBodyAsString();
			// TODO remove at delivery
			saveFile(body,"upload.html");
			m.releaseConnection();
			
			System.out.println("=====================================\n\n\n");

			MultipartPostMethod upload = new MultipartPostMethod("http://azure.freeservers.com/cgi-bin/util/fm_nmp/?Xtime="+String.valueOf(System.currentTimeMillis()));
			conf.setHost("azure.freeservers.com");
			addCommonHeaders(upload);
			//upload.setStrictMode(true);
			//upload.addParameter("uploadfile1", file);
			FilePart filepart = new FilePart("uploadfile1", "bom12.txt", file);
			upload.addPart(filepart);
			StringPart part = new StringPart("submit","Login!");
			upload.addPart(part);
			part = new StringPart("selector","");
			upload.addPart(part);
			part = new StringPart("viewer","");
			upload.addPart(part);
			part = new StringPart("destfolder1","Choose a Destination...");
			upload.addPart(part);
			part = new StringPart("destfolder2","Choose a Destination...");
			upload.addPart(part);
			client.executeMethod(conf,upload,state);
			body = upload.getResponseBodyAsString();
			// TODO remove at delivery
			saveFile(body,"uploaded.html");
			upload.releaseConnection();
			System.out.println(8);
			
		} catch (HttpException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		disconnect();
	}
	
	
	protected void callTrack(String url) throws HttpException, IOException {
		GetMethod m = new GetMethod(url);
		conf.setHost("azure.freeservers.com");
		addCommonHeaders(m);
		//m.addRequestHeader("Host","azure.freeservers.com");
		client.executeMethod(conf,m,state);
		m.releaseConnection();	
	} 

	public void saveFile(String str, String filename) {
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(filename);
			fos.write(str.getBytes());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				fos.flush();
				fos.close();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
			
		}
	}
}
